package eu.openaire.urls_controller.models;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

//import javax.persistence.Column;
import java.io.Serializable;
import java.util.Date;


//@Entity
//@Table(name = "payload")
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
        "id",
        "original_url",
        "actual_url",
        "date",
        "mime_type",
        "size",
        "hash",
        "location",
        "provenance"
})
public class Payload implements Serializable {

    //@Column(name = "id")
    @JsonProperty("id")
    private String id;

    //@Column(name = "original_url")
    @JsonProperty("original_url")
    private String original_url;

    //@Column(name = "date")
    @JsonProperty("actual_url")
    private String actual_url;

    //@Column(name = "date")
    @JsonProperty("date")
    private Date date_acquired;

    //@Column(name = "mimetype")
    @JsonProperty("mime_type")
    private String mime_type;

    //@Column(name = "size")
    @JsonProperty("size")
    private Long size;  // In bytes.

    //@Column(name = "hash")
    @JsonProperty("hash")
    private String hash;

    //@Column(name = "location")
    @JsonProperty("location")
    private String location;

    //@Column(name = "provenance")
    @JsonProperty("provenance")
    private String provenance;  // "crawl:<PluginName>"


    public Payload(String id, String original_url, String actual_url, Date date_acquired, String mime_type, Long size, String hash, String location, String provenance) {
        this.id = id;
        this.original_url = original_url;
        this.actual_url = actual_url;
        this.date_acquired = date_acquired;
        this.mime_type = mime_type;
        this.size = size;
        this.hash = hash;
        this.location = location;
        this.provenance = provenance;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getOriginal_url() {
        return original_url;
    }

    public void setOriginal_url(String original_url) {
        this.original_url = original_url;
    }

    public String getActual_url() {
        return actual_url;
    }

    public void setActual_url(String actual_url) {
        this.actual_url = actual_url;
    }

    public Date getDate_acquired() {
        return date_acquired;
    }

    public void setDate_acquired(Date date_acquired) {
        this.date_acquired = date_acquired;
    }

    public String getMime_type() {
        return mime_type;
    }

    public void setMime_type(String mime_type) {
        this.mime_type = mime_type;
    }

    public Long getSize() {
        return size;
    }

    public void setSize(Long size) {
        this.size = size;
    }

    public String getHash() {
        return hash;
    }

    public void setHash(String hash) {
        this.hash = hash;
    }

    public String getLocation() {
        return location;
    }

    public void setLocation(String location) {
        this.location = location;
    }

    public String getProvenance() {
        return provenance;
    }

    public void setProvenance(String provenance) {
        this.provenance = provenance;
    }

    @Override
    public String toString() {
        return "Payload{" +
                "id='" + id + '\'' +
                ", original_url='" + original_url + '\'' +
                ", actual_url='" + actual_url + '\'' +
                ", date_acquired='" + date_acquired + '\'' +
                ", mime_type='" + mime_type + '\'' +
                ", size='" + size + '\'' +
                ", md5='" + hash + '\'' +
                ", location='" + location + '\'' +
                ", provenance='" + provenance + '\'' +
                '}';
    }
}
